import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.CommandHelper
import groovy.json.*
import java.lang.Object.*


def ch = new CommandHelper(new File('.'));
def ahpTool = new AHPTool();
def pluginHome = System.getenv("PLUGIN_HOME");
def props = ahpTool.getStepProperties();

def executable;

if (ahpTool.isWindows) {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient.cmd";
}
else {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient";
     def chmod = ["chmod", "a+x", executable];
     ch.runCommand("Making client executable.", chmod);
}

def url = props['integration/url'];
def user = props['integration/user'];
def authToken = props['integration/authToken'];
def password = props['integration/passScript'];

if (password == null || password.trim() == "") {
    password = props['integration/password'];
}


def compName = props['componentName'];
def versionName = props['versionName'];
def statusName = props['statusName'];


if (Boolean.valueOf(props['onlyChanged'])){
	isTrue = true
}


def cmdArgs = [executable,
             "--weburl", url, "addVersionStatus", 
             "--component", compName, "--version", versionName, "--status", statusName];
if (authToken) {
    cmdArgs << "--authtoken" << authToken
}
else {
    cmdArgs << "--username" << user << "--password" << password
}

ch.runCommand("Adding $statusName to version $versionName of $compName", cmdArgs);

