import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.CommandHelper
import groovy.json.*
import java.lang.Object.*


def ch = new CommandHelper(new File('.'));
def ahpTool = new AHPTool();
def pluginHome = System.getenv("PLUGIN_HOME");
def props = ahpTool.getStepProperties();

def executable;

if (ahpTool.isWindows) {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient.cmd";
}
else {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient";
     def chmod = ["chmod", "a+x", executable];
     ch.runCommand("Making client executable", chmod);
}

def url = props['integration/url'];
def user = props['integration/user'];
def authToken = props['integration/authToken'];
def password = props['integration/passScript'];

if (password == null || password.trim() == "") {
    password = props['integration/password'];
}


def applicationName = props['applicationName'];
def appProcess = props['applicationProcess'];
def envName = props['environmentName'];
def deployOnlyChanged = props['onlyChanged'];
def compName = props['componentName'];
def versionName = props['versionName'];
def postURL = props['postURL'];
def postMessage = props['postMessage'];
boolean isTrue = false

if (Boolean.valueOf(props['onlyChanged'])){
	isTrue = true
}


def jsonBody = "{\"application\": " + "\"$applicationName\"" + ", \"applicationProcess\":  " +"\"$appProcess\""+ ", \"environment\": " +"\"$envName\""+ ", \"onlyChanged\": " +"\"$isTrue\""+ ", \"properties\": {},\"versions\": [{\"version\": " +"\"$versionName\""+ ", \"component\": " +"\"$compName\""+ " }],\"post-deploy-put-url\": " +"\"$postURL\""+ ", \"post-deploy-message\": " +"\"$postMessage\"}";



println("Printing json")
println jsonBody

jsonFile = new File("deploy.json")

if(jsonFile.exists()){
	jsonFile.delete()
	jsonFile << jsonBody
   } else {
    jsonFile << jsonBody
}


def cmdArgs = [executable,
             "--weburl", url, "requestApplicationProcess", jsonFile];
if (authToken) {
    cmdArgs << "--authtoken" << authToken
}
else {
    cmdArgs << "--username" << user << "--password" << password
}

ch.runCommand("Triggering Deployment", cmdArgs);

