import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.CommandHelper

def ch = new CommandHelper(new File('.'));
def ahpTool = new AHPTool();
def pluginHome = System.getenv("PLUGIN_HOME");
def props = ahpTool.getStepProperties();

def executable;

if (ahpTool.isWindows) {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient.cmd";
}
else {
     executable = pluginHome + File.separator + "udclient" + File.separator + "udclient";
     def chmod = ["chmod", "a+x", executable];
     ch.runCommand("Making client executable", chmod);
}

def url = props['integration/url'];
def user = props['integration/user'];
def authToken = props['integration/authToken'];
def password = props['integration/passScript'];

if (password == null || password.trim() == "") {
    password = props['integration/password'];
}

def componentName = props['componentName'];
def versionName = props['versionName'];
def baseDir = props['baseDir'];
def offset = props['offset'];

def cmdArgs = [executable, "--verbose",
               "--weburl", url, "createVersion", "--component", componentName, "--name", versionName];
if (authToken) {
    cmdArgs << "--authtoken" << authToken
}
else {
    cmdArgs << "--username" << user << "--password" << password
}

ch.runCommand("Creating version", cmdArgs);

if (props['publishFiles'] != null && Boolean.valueOf(props['publishFiles'])) {
    cmdArgs = [executable,
                   "--weburl", url, "addVersionFiles", "--component", componentName, "--version", versionName, "--base", baseDir];
    if (authToken) {
        cmdArgs << "--authtoken" << authToken
    }
    else {
        cmdArgs << "--username" << user << "--password" << password
    }

    if (offset != null && offset.trim() != "") {
        cmdArgs << offset;
    }

    ch.runCommand("Publishing Files", cmdArgs);
}
